﻿Public Class formEnvioSMS

    'Función para quitar los saltos de línea de un texto
    Private Function quitarSaltosLinea(ByVal texto As String,
                      caracterReemplazar As String) As String
        quitarSaltosLinea = Replace(Replace(texto, Chr(10),
                caracterReemplazar), Chr(13), caracterReemplazar)
    End Function

    Private Function obtenerCobertura(
                      ByVal texto As String) As Double
        Dim pos As Integer
        Dim textoTemp As String

        texto = quitarSaltosLinea(texto, " ")
        pos = texto.IndexOf("CSQ:") + Len("CSQ:") + 1
        textoTemp = Mid(texto, pos, Len(texto))
        textoTemp = Trim(Replace(textoTemp, "OK", ""))

        obtenerCobertura = CDbl(textoTemp)
    End Function

    'Obtener los puertos Serie (COM) disponibles en el PC
    Function obtenerPuertosSeriePC() As List(Of String)
        Dim puertosSerie As List(Of String)

        puertosSerie = New List(Of String)
        Try
            puertosSerie = New List(Of String)
            For Each puertosSerieObtenidos As String
                        In My.Computer.Ports.SerialPortNames
                puertosSerie.Add(puertosSerieObtenidos)
            Next
            obtenerPuertosSeriePC = puertosSerie
        Catch ex As Exception
            MsgBox(ex.Message, MsgBoxStyle.Critical +
                   MsgBoxStyle.OkOnly)
            obtenerPuertosSeriePC = puertosSerie
        End Try
    End Function

    'Abre el puerto serie pasado como parámetro
    Sub abrirPuertoSerie(ByVal puerto As String)
        Try
            With compPuertoSerie
                If .IsOpen Then
                    .Close()
                End If

                .PortName = puerto
                .BaudRate = CInt(lsBitPorSegundo.Text)
                .DataBits = CInt(lsBitDatos.Text)
                Select Case lsBitsParada.Text
                    Case "1"
                        .StopBits = IO.Ports.StopBits.One
                    Case "1.5"
                        .StopBits = IO.Ports.StopBits.OnePointFive
                    Case "2"
                        .StopBits = IO.Ports.StopBits.Two
                    Case "Ninguno"
                        .StopBits = IO.Ports.StopBits.None
                End Select

                Select Case lsParidad.Text
                    Case "Par"
                        .Parity = IO.Ports.Parity.Even
                    Case "Impar"
                        .Parity = IO.Ports.Parity.Odd
                    Case "Ninguno"
                        .Parity = IO.Ports.Parity.None
                    Case "Marca"
                        .Parity = IO.Ports.Parity.Mark
                    Case "Espacio"
                        .Parity = IO.Ports.Parity.Space
                End Select

                Select Case lsControlFlujo.Text
                    Case "Hardware"
                        .Handshake = IO.Ports.Handshake.RequestToSend
                    Case "Xon / Xoff"
                        .Handshake = IO.Ports.Handshake.XOnXOff
                    Case "Ninguno"
                        .Handshake = IO.Ports.Handshake.None
                    Case "Hardware y Xon/Xoff"
                        .Handshake = IO.Ports.Handshake.RequestToSendXOnXOff
                End Select

                .DtrEnable = False

                .ReadBufferSize = CInt(txtTamanoBufferLectura.Text)
                .WriteBufferSize = CInt(txtTamanoBufferEscritura.Text)
                .WriteTimeout = CInt(txtTiempoEspera.Text)
                .RtsEnable = True
                .Encoding = System.Text.Encoding.Default
                .Open()
            End With

        Catch ex As Exception
            MsgBox("Error al abrir el puerto serie: " &
                   ex.Message, MsgBoxStyle.Critical)
        End Try
    End Sub



    Private Sub btObtenerPuertos_Click(sender As System.Object,
                  e As System.EventArgs) Handles btObtenerPuertos.Click
        Dim puertosSerie As List(Of String)
        Dim i As Integer

        txtPuerto.Items.Clear()

        puertosSerie = obtenerPuertosSeriePC()
        For i = 0 To puertosSerie.Count - 1
            txtPuerto.Items.Add(puertosSerie(i).ToString)
        Next

        If txtPuerto.Items.Count >= 1 Then
            txtPuerto.Text = txtPuerto.Items(0)
        Else
            txtPuerto.Text = ""
        End If

        If puertosSerie.Count = 0 Then
            MsgBox("No se han detectado puertos serie en su equipo, " +
                   "asegúrese de que están correctamente configurados.",
                   MsgBoxStyle.Information + MsgBoxStyle.OkOnly)
        End If
    End Sub


    Private Sub btConectar_Click(sender As System.Object,
                  e As System.EventArgs) Handles btConectar.Click
        Dim posBusqueda As Integer
        Dim resultadoDevuelto As String

        Try
            If btConectar.Text = "Conectar" Then
                If txtPuerto.Text = "" Or
                        txtTamanoBufferEscritura.Text = "" Or
                        txtTamanoBufferLectura.Text = "" Or
                        txtTiempoEspera.Text = "" Or
                        lsBitDatos.Text = "" Or
                        lsBitPorSegundo.Text = "" Or
                        lsBitsParada.Text = "" Or
                        lsControlFlujo.Text = "" Or
                        lsParidad.Text = "" Then
                    MsgBox("Antes de conectar con el puerto serie " &
                           "debe introducir los datos " &
                            "de conexión con el módem GSM y la tarjeta SIM.",
                            MsgBoxStyle.Information + MsgBoxStyle.OkOnly)
                Else
                    abrirPuertoSerie(txtPuerto.Text)

                    'Comprobar si hay un módem GSM conectado al puerto serie
                    compPuertoSerie.Write("AT" & Chr(13))
                    'Esperamos un segundo para dar tiempo a 
                    'las comunicaciones serie
                    System.Threading.Thread.Sleep(1000)
                    'Si el comando AT devuelve OK es que hay módem GSM
                    If compPuertoSerie.ReadExisting().IndexOf("OK") Then
                        bePModem.Text = "Módem GSM activo"
                        bePModem.ForeColor = Color.Green
                    Else
                        bePModem.Text = "Módem GSM no encontrado"
                        bePModem.ForeColor = Color.Red
                    End If
                    'Limpiamos el bugger de datos de entrada 
                    'devueltos por el módem GSM
                    compPuertoSerie.DiscardInBuffer()

                    'Comprobar si el módem módem GSM está conectado a una red GSM
                    compPuertoSerie.Write("AT+CREG?" & Chr(13))
                    System.Threading.Thread.Sleep(1000)
                    'Si el comando AT+CREG? devuelve 0,1 es que hay red móvil
                    If compPuertoSerie.ReadExisting().IndexOf("0,1") Then
                        bePRedMovil.Text = "Red móvil disponible"
                        bePRedMovil.ForeColor = Color.Green
                    Else
                        bePRedMovil.Text = "No hay red móvil"
                        bePRedMovil.ForeColor = Color.Red
                    End If
                    compPuertoSerie.DiscardInBuffer()

                    'Obtener la intensidad de la señal (cobertura) del módem GSM
                    'máximo: 31.99
                    compPuertoSerie.Write("AT+CSQ" & Chr(13))
                    System.Threading.Thread.Sleep(1000)
                    resultadoDevuelto = compPuertoSerie.ReadExisting()
                    posBusqueda = resultadoDevuelto.IndexOf("+CSQ: ")
                    If posBusqueda >= 0 Then
                        bpSenal.Minimum = 0
                        bpSenal.Maximum = 39
                        bpSenal.Value = obtenerCobertura(resultadoDevuelto)
                    Else
                        bpSenal.Minimum = 0
                        bpSenal.Value = 0
                        bpSenal.Minimum = 39
                    End If
                    compPuertoSerie.DiscardInBuffer()

                    'Obtener ID del dispositivo GSM (IMEI)
                    compPuertoSerie.Write("AT+CGSN" & Chr(13))
                    System.Threading.Thread.Sleep(1000)
                    resultadoDevuelto = compPuertoSerie.ReadExisting()
                    posBusqueda = resultadoDevuelto.IndexOf("CGSN")
                    If posBusqueda >= 0 Then
                        resultadoDevuelto =
                            quitarSaltosLinea(resultadoDevuelto, " ")
                        bePID.Text = "IMEI: " &
                            Replace(Mid(resultadoDevuelto,
                            posBusqueda + Len("CGSN") + 1,
                            Len(resultadoDevuelto)), "OK", "")
                    End If

                    btConectar.Text = "Desconectar"
                End If
            Else
                If compPuertoSerie.IsOpen Then
                    compPuertoSerie.Close()
                End If
                btConectar.Text = "Conectar"
            End If
        Catch ex As Exception
            MsgBox("Error al abrir el puerto serial: " &
                   ex.Message, MsgBoxStyle.Critical)
        End Try
    End Sub

    Private Sub btEnviarSMS_Click(sender As System.Object,
                   e As System.EventArgs) Handles btEnviarSMS.Click
        If Not compPuertoSerie.IsOpen Then
            tabPes.SelectedTab = tabConfiguracionModem
            MsgBox("Antes de enviar el SMS debe introducir los datos " &
                    "de conexión con el módem GSM y la tarjeta SIM y " &
                    "conectar con el puerto serie.",
                    MsgBoxStyle.Information + MsgBoxStyle.OkOnly)
        Else
            If txtNumeroTelefono.Text = "" Or txtSMS.Text = "" Then
                MsgBox("Debe introducir el número de teléfono al  " &
                        "que se enviará el SMS y el texto del SMS.",
                        MsgBoxStyle.Information + MsgBoxStyle.OkOnly)

            Else
                Try
                    'Activar modo SMS en dispositivo GSM
                    compPuertoSerie.Write("AT+CMGF=1" & Chr(13))
                    System.Threading.Thread.Sleep(1000)
                    'Establecer número de teléfono de destino del SMS
                    compPuertoSerie.Write("AT+CMGS=" & Chr(34) &
                                          (txtNumeroTelefono.Text) &
                                          Chr(34) & Chr(13))
                    System.Threading.Thread.Sleep(1000)
                    'Enviar texto SMS a dispositivo GSM
                    compPuertoSerie.Write(txtSMS.Text & Chr(26))
                    Application.DoEvents()
                    System.Threading.Thread.Sleep(1000)
                    MsgBox("El SMS ha sido enviado al número " &
                           txtNumeroTelefono.Text & ".",
                            MsgBoxStyle.Information + MsgBoxStyle.OkOnly)
                Catch ex As Exception
                    MsgBox(ex.Message, MsgBoxStyle.Critical +
                           MsgBoxStyle.OkOnly)
                End Try
            End If
        End If
    End Sub

    Private Sub btEnviarATPrueba_Click(sender As System.Object,
                     e As System.EventArgs) _
                     Handles btEnviarATPrueba.Click
        Try
            compPuertoSerie.Write(txtComandoAT.Text & Chr(13))
        Catch ex As Exception
            MsgBox(ex.Message, MsgBoxStyle.Critical +
                   MsgBoxStyle.OkOnly)
        End Try
    End Sub

    'NOTA: este evento del SerialPort se ejecuta en un Thread 
    'diferente al de la aplicación, por lo que los datos devueltos 
    'por el puerto serie no tienen por qué ser instantáneos, puede que tengan retraso
    Private Sub compPuertoSerie_DataReceived(sender As System.Object,
            e As System.IO.Ports.SerialDataReceivedEventArgs) _
            Handles compPuertoSerie.DataReceived
        Dim resultadoModemGSM As String

        Try
            'Obtener el resultado devuelto por el puerto serie
            resultadoModemGSM =
                compPuertoSerie.ReadExisting.Trim().ToString

            If txtResultado.Text <> "" Then
                txtResultado.Text = txtResultado.Text + vbCrLf +
                       resultadoModemGSM
            Else
                txtResultado.Text = resultadoModemGSM
            End If

            'Mostrar última línea del TextBox
            txtResultado.Select(txtResultado.Text.Length, 0)
            txtResultado.ScrollToCaret()

        Catch ex As Exception
            MsgBox(ex.Message, MsgBoxStyle.Critical +
                   MsgBoxStyle.OkOnly)
        End Try
    End Sub

    Private Sub formEnvioSMS_Load(sender As System.Object,
                e As System.EventArgs) Handles MyBase.Load
        'Desactivar detección a llamadas en subprocesos equivocados
        CheckForIllegalCrossThreadCalls = False
    End Sub

    Private Sub btPIN_Click(sender As System.Object,
                e As System.EventArgs) Handles btPIN.Click
        Try
            'Enviar PIN a tarjeta SIM del dispositivo módem GSM
            compPuertoSerie.Write("AT+CPIN=" &
                                  txtPIN.Text & Chr(13))
        Catch ex As Exception
            MsgBox(ex.Message, MsgBoxStyle.Critical +
                   MsgBoxStyle.OkOnly)
        End Try
    End Sub

    Private Sub btDefecto_Click(sender As System.Object,
               e As System.EventArgs) Handles btDefecto.Click
        lsBitPorSegundo.Text = "9600"
        lsBitDatos.Text = "8"
        lsParidad.Text = "Ninguno"
        lsBitsParada.Text = "1"
        lsControlFlujo.Text = "Ninguno"
        txtTamanoBufferLectura.Text = "1024"
        txtTamanoBufferEscritura.Text = "1024"
        txtTiempoEspera.Text = "500"
    End Sub

    Private Sub linkURL_LinkClicked(sender As System.Object,
               e As System.Windows.Forms.LinkLabelLinkClickedEventArgs) _
               Handles linkURL.LinkClicked
        System.Diagnostics.Process.Start("http://www.ajpdsoft.com")
    End Sub
End Class
